/* 
 * MulticastCapsuleCacheKey.Java
 *
 * Copyright (c) 1999 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */
package JANOS_ANTSR_MULTICAST_APP_PKG;

/**
 * This is a wrapper object used as a key to obtain the multicast
 * soft-state (the cacheObject above).
 * 
 * @author <a href="mailto:janos-discuss@flux.cs.utah.edu>Janos Ministry of Development</a>
 */
PACKAGE class MulticastCapsuleCacheKey {
	public int group;
	public int target;
	
	public MulticastCapsuleCacheKey(int group, int target) {
		this.group = group;
		this.target = target;
	}
	private MulticastCapsuleCacheKey() {}
	public int hashCode() { return group; }
	public boolean equals(Object o) {
		if (o != null
		    && o instanceof MulticastCapsuleCacheKey
		    && this.group == ((MulticastCapsuleCacheKey)o).group
		    && this.target == ((MulticastCapsuleCacheKey)o).target)
			return true;
		else return false;
	}
}
