/*
 * FlowRun.Java
 *
 * Copyright (c) 1999 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */
package JANOS_NODEOS_PKG;

/**
 * A protocol should override FlowRun so that a flow can
 * be created for it.  When the flow is created, the overridden run()
 * method is called.
 *
 * @author <a href="mailto:janos-discuss@flux.cs.utah.edu>Janos Ministry of Development</a>
 */
abstract public class FlowRun
{
	protected abstract void run(
		Flow flow,
		ThreadPool threadPool,
		String[] args,
		CommSpaceHandle csh)
		throws Exception;

	// XXX we don't really need these, do we?
	protected abstract BufferHandle newBufferHandle();
	protected abstract void recycleBufferHandle(BufferHandle b);
}
