/*
 * ANEPDemultiplexKeyTester.Java
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

package JANOS_TESTS_ANTSR_CORE_PKG;

import JANOS_TESTS_PKG.*;
import JANOS_ANTSR_CORE_PKG.*;

public class ANEPDemultiplexKeyTester extends Tester
{
	public void testUnit() throws TestFailedException
	{
		this.enterSection(ENV_EXPOSED, "Constructor");
#ifdef EXPOSED
		short pid = (short)0xf00d;
		ANEPDemultiplexKey adk = new ANEPDemultiplexKey(0, pid);
		byte buf[] = {
			Capsule.ANEPVERSION, /* Version */
			0, /* Flags */
			(byte)0xF0, (byte)0x0D, /* Type ID */
			0, 0, /* Header Length */
			0, 0, /* Packet Length */
			0, 0, 0, 0 /* Options */
		};

		this.test(adk.matches(buf, 0, buf.length) == 4);
		buf[2] = 0;
		this.test(adk.matches(buf, 0, buf.length) == 0);
#endif
	}
}
