/*
 * ANTSDemultiplexKeyTester.Java
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

package JANOS_TESTS_ANTSR_CORE_PKG;

import JANOS_TESTS_PKG.*;
import JANOS_ANTSR_CORE_PKG.*;

public class ANTSRDemultiplexKeyTester extends Tester
{
	public void testUnit() throws TestFailedException
	{
		this.enterSection(ENV_EXPOSED, "Constructor");
#ifdef EXPOSED
		byte midBytes[] = {
			0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
			0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f
		};
		byte buf[] = new byte[128];
		Xdr xdr = new Xdr(buf, 0, buf.length);
		int lpc;
		
		xdr.PUT(Capsule.ANEPVERSION);
		xdr.PUT((byte)0);
		xdr.PUT(Capsule.ANTSRTYPE);
		xdr.PUT((short)8);
		xdr.PUT((short)0);
		
		xdr.PUT(Capsule.DESTOPTTYPE); // destination option
		xdr.PUT((short)3);
		xdr.PUT(Capsule.IPV4SCHEME);
		xdr.PUT(0);
		
		xdr.PUT(Capsule.SRCOPTTYPE); // source option
		xdr.PUT((short)3);
		xdr.PUT(Capsule.IPV4SCHEME);
		xdr.PUT(0);
		
		xdr.PUT(Capsule.ANTSRVERSION);
		xdr.PUT(midBytes, 0, Xdr.TYPEID);
		xdr.PUT((int)0);
		xdr.PUT((int)0);
		xdr.PUT((int)0);
		xdr.PUT((int)5);
		
		ANTSRDemultiplexKey adk = new ANTSRDemultiplexKey(midBytes);
		this.test(adk.matches(buf, 0, buf.length) ==
			  Xdr.INT + (8 * 4) + midBytes.length);
		this.test(adk.matches(buf, 0, buf.length - 12) !=
			  Xdr.INT + (8 * 4));
#endif
	}
}
