/*
 * BufferTester.Java
 *
 * Copyright (c) 1999, 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

package JANOS_TESTS_NODEOS_PKG;

import JANOS_TESTS_PKG.*;
import JANOS_NODEOS_PKG.*;

public class BufferTester extends Tester
{
	public void testUnit() throws TestFailedException
	{
		this.enterSection(ENV_EXPOSED, "Buffer");
#ifdef EXPOSED
		byte byteArray[];
		Buffer buf;

		this.enterSection(ENV_EXPOSED, "Constructor");
		byteArray = new byte[1024];
		buf = new Buffer(byteArray);
		this.enterSection(ENV_EXPOSED, "instance data");
		this.test(buf.refCount == 1);
		this.test(buf.data == byteArray);
		this.enterSection(ENV_EXPOSED, "acquire()/release()");
		buf.acquire();
		this.test(buf.refCount == 2);
		buf.release();
		this.test(buf.refCount == 1);
		buf.release();
		this.test(buf.refCount == 0);
		this.test(buf.recycled == true);
		try
		{
			buf.release();
			throw new TestFailedException(this);
		}
		catch(IllegalStateException e)
		{
			; /* Nothing */
		}
#endif
	}
}
