/*
 * FreeList.Java
 *
 * Copyright (c) 1999 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */
package JANOS_UTIL_PKG;

public class FreeList
{
	FreeListElement fullElements;
	FreeListElement emptyElements;

	public synchronized Object getFree()
	{
		FreeListElement e = fullElements;

		if(e != null)
		{
			fullElements = e.next;
			e.next = emptyElements;
			emptyElements = e;
			return e.o;
		}
		else return null;
	}

	public synchronized void addFree(Object o)
	{
		FreeListElement e = emptyElements;
		if(e == null) e = new FreeListElement();

		e.o = o;
		emptyElements = e.next;
		e.next = fullElements;
		fullElements = e;
	}
}

class FreeListElement
{
	Object o;
	FreeListElement next;
}

